Ext.namespace("dSS", "dSS.config", "dSS.devprops");
dSS.devprops.VisibilityMatrix = {
    'GE' :  { },
    'GN' :  { },
    'RT' :  { },
    'GR' :  { },
    'BL' :  { },
    'TK' :  { },
    'SW' :  { }
};

dSS.devprops.ErrorMatrix = {};

dSS.devprops.GetVisibleProperties = function(record) {
    var none = dSS.devprops.ErrorMatrix;

    if (!record) {
        throw none;
    }

    var devInfo = dSS.util.parseProductID(record.get('productID'));
    var devType = devInfo[0];
    var devNumber = devInfo[1];
    var fInfo = dSS.util.parseFunctionID(record.get('functionID'));
    var devClass = fInfo[0];
    var modelUID = record.get('VdcModelUID');

    var dc = dSS.devprops.VisibilityMatrix[dSS.config.deviceColors[devClass]];
    if (dc === undefined) {
        throw none;
    }

    var ret;

    if (String(modelUID).length > 0) {
        ret = dc[modelUID];
        if (ret !== undefined) {
            return ret;
        } else {
            throw none;
        }
    }

    var key = dSS.config.deviceTypes[devType] + ':' + devNumber;
    ret = dc[key];
    if (ret === undefined) {
        // try wildcard - devType NNx
        key = dSS.config.deviceTypes[devType] + ':' +
              String(devNumber).charAt(0) + String(devNumber).charAt(1);
        ret = dc[key];
        if (ret !== undefined) {
            return ret;
        }
        // try wildcard - devType Nxx
        key = dSS.config.deviceTypes[devType] + ':' +
              String(devNumber).charAt(0);
        ret = dc[key];
        if (ret === undefined) {
            throw none;
        } else {
            return ret;
        }
    } else {
        return ret;
    }
};

